View Issue Details

IDProjectCategoryView StatusLast Update
0003176SketcherBugpublic2017-12-02 12:03
ReporterMatthijsAssigned Towmayer 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformGNU/LinuxOSDebianOS Version8
Product Version0.17 
Target Version0.17Fixed in Version0.17 
Summary0003176: Sketcher: always over-constrained when referencing external B-Spline
DescriptionIn short: when a sketch contains an External Reference to a B-Spline, the sketch cannot be solved. It will either have >=1 remaining degrees of freedom (which is correct), or will be marked as over-constrained (which is not correct).

See this forum thread for a longer explanation, a confirmation, a comparison by another user, a 2nd method to reproduce, etc.
Steps To ReproducePreparation steps: (already done in the attached file)
  1. Start with a blank fcstd file
  2. Go to the Part Design workbench
  3. Create a new Part
  4. Add a new Body to the Part
  5. Create a Sketch, for example in the XY plane
  6. Draw a closed shape, containing a B-Spline
  7. Make the sketch fully constrained and close the Sketcher
  8. Pad the sketch
  9. Select the top face of the Pad
  10. Create a new sketch on that face
  11. In the Sketcher, click the B-Spline curve with the tool "Create an edge linked to an external geometry (X)"
  12. Draw some other features (lines, arcs, etc). You do not need to actually do something with the referenced B-Spline.

Observations:
  1. As long as the sketch is under-constrained, the solver displays the correct # degrees of freedom. See attachment 'ext_ref_spline' for a file in this situation: there is only 1 degree of freedom left: the height of the triangle.
  2. Now the bug: as soon as you try to make the sketch fully constrained, the solver will protest and say that the sketch is over-constrained. See the forum topic for more details.
Additional InformationOS: Debian GNU/Linux 8.9 (jessie)
Word size of OS: 64-bit
Word size of FreeCAD: 64-bit
Version: 0.17.11958 (Git)
Build type: Release
Branch: master
Hash: c9957b8a98e71b2a69c71b9f92acf1cf01afcc35
Python version: 2.7.9
Qt version: 4.8.6
Coin version: 4.0.0a
OCC version: 6.8.0.oce-0.17
Locale: Dutch/Netherlands (nl_NL)
Tagsb-splines, constraints

Activities

Matthijs

2017-09-05 19:19

reporter  

ext_ref_spline.fcstd (10,187 bytes)

Kunda1

2017-09-06 02:55

administrator   ~0010071

@abdullah care to take a look at this ?

wmayer

2017-12-02 12:03

administrator   ~0010506

https://github.com/FreeCAD/FreeCAD/commit/adfcd154c672f15fb5e786c3713e1e733947862f

Issue History

Date Modified Username Field Change
2017-09-05 19:19 Matthijs New Issue
2017-09-05 19:19 Matthijs File Added: ext_ref_spline.fcstd
2017-09-05 19:48 Kunda1 Tag Attached: b-splines
2017-09-05 19:48 Kunda1 Tag Attached: constraints
2017-09-06 02:55 Kunda1 Note Added: 0010071
2017-09-06 02:56 Kunda1 Status new => confirmed
2017-10-18 12:55 wmayer Target Version => 0.17
2017-12-02 12:03 wmayer Assigned To => wmayer
2017-12-02 12:03 wmayer Status confirmed => closed
2017-12-02 12:03 wmayer Resolution open => fixed
2017-12-02 12:03 wmayer Fixed in Version => 0.17
2017-12-02 12:03 wmayer Note Added: 0010506